# $Id: install.py,v 1.10 2002/07/15 07:47:06 gitte Exp $
# $Source: /usr/local/cvs_root/MMMSkins/Extensions/install.py,v $
__version__ = "$Revision: 1.10 $"[11:-2]
from App.Common import package_home
from Products.CMFCore.DirectoryView import addDirectoryViews, createDirectoryView
from Products.CMFCore.utils import getToolByName, minimalpath
from Products.MMMSkins import mmmskins_globals
from Products.ExternalMethod import ExternalMethod
from cStringIO import StringIO
import string

out = StringIO()

def removeSkin(self, skinname):
    """
    Remove a skin from portal_skins
    """
    skinstool = getToolByName(self, 'portal_skins')
    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if skinname in path:
            path.remove(skinname)
            path = string.join(path, ', ')
            # addSkinSelection will replace existing skins as well.
            skinstool.addSkinSelection(skin, path)
            out.write("Removed %s from %s skin\n" % (skinname, skin))

    if skinname in skinstool.objectIds():
        skinstool._delObject(skinname)
        out.write('Removed %s from the skinstool\n' % skinname)

def install(self):
    """Register skins"""
    out.write('MyMediaManager Skins Installation\n')
    out.write('=======================================\n\n')
    skinstool = getToolByName(self, 'portal_skins')
    portalroot = getToolByName(self, 'portal_url').getPortalObject()
    portalcatalog = getToolByName(self, 'portal_catalog')

    if not 'transitions' in portalroot.objectIds():
        i = ExternalMethod.ExternalMethod('transitions', 'Get transitions from portal_workflow', 'MMMSkins.utils', 'getTransitions')
        portalroot._setObject('transitions', i)
        out.write('Created transitions method\n')
    else:
        out.write('transitions method already existed\n')

    if not 'Language' in portalcatalog.Indexes.objectIds():
        portalcatalog.addIndex('Language', 'FieldIndex')
        out.write('Added Language to the portal catalog\n')
    else:
        out.write('Language already existed in the portal catalog\n')

    if not 'portal_boxtool' in portalroot.objectIds():
        portalroot.manage_addProduct['MMMSkins'].manage_addTool('Box Tool', None)
        out.write('Created Box Tool\n')
    else:
        out.write('Box Tool already existed\n')

    # Setup the skins
    if 'mmm_skins' not in skinstool.objectIds():
        # We need to add Filesystem Directory Views for any directories
        # in our skins/ directory.  These directories should already be
        # configured.
        fp = minimalpath("%s/zpt_skins" % package_home(mmmskins_globals))
        createDirectoryView(skinstool, fp, 'mmm_skins')
        #addDirectoryViews(skinstool, 'zpt_skins', fp)
        out.write("Added 'mmm_skins' directory view to portal_skins\n")
    else:
        out.write("'mmm_skins' directory view already exists in portal_skins\n")
    # Now we need to go through the skin configurations and insert
    # 'mmm_skins' into the configurations.  Preferably, this
    # should be right after where 'after' is placed.  Otherwise, we
    # append it to the end.
    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if 'mmm_skins' not in path:
            try:
               path.insert(path.index('custom')+1, 'mmm_skins')
            except ValueError:
                path.append('mmm_skins')

            path = string.join(path, ', ')
            # addSkinSelection will replace existing skins as well.
            skinstool.addSkinSelection(skin, path)
            out.write("Added 'mmm_skins' to %s skin\n" % skin)
        else:
            out.write("Skipping %s skin, 'mmm_skins' is already set up\n" % (skin))

    return out.getvalue()

def uninstall(self):
    """
    Remove skins, types and special objects
    """
    portalroot = getToolByName(self, 'portal_url').getPortalObject()
    out.write('MyMediaManager Skins Un-Installation\n')
    out.write('===========================\n\n')

    removeSkin(self, 'mmm')
    if 'portal_boxtool' in portalroot.objectIds():
        portalroot._delObject('portal_boxtool')
        out.write('Removed Box Tool\n')
        
    return out.getvalue()
