import zLOG, os
import string
from cStringIO import StringIO
from Products.CMFCore.utils import getToolByName
from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate

def writeLog(class_name, logtext):
    zLOG.LOG(class_name, zLOG.INFO, logtext)

def PUT_factory( self, name, typ, body ):
    """
        Override the default PUT method to make ZWikiPage the
        default type for ftp uploads
    """
    major, minor = string.split( typ, '/' )
    if major != 'image':
        return ZopePageTemplate( name )
    zLOG.LOG("PUT_factory", zLOG.INFO, "name: %s - type: %s" % (name, typ))
    return None

def getTransitions(self):
    out = StringIO()
    #out.write('Testing Get Transitions\n')
    #out.write('-----------------------\n\n')
    wf_tool = getToolByName(self, 'portal_workflow')
    transitionlist = []
    for id in wf_tool.getWorkflowIds():
        #out.write('ID: %s\n' % id)
        if id != 'collector_issue_workflow':
            wf = wf_tool.getWorkflowById(id)
            #out.write('Workflow dict: %s\n' % str(wf.__dict__))
            if hasattr(wf, 'transitions'):
                #out.write('Transitions dict: %s\n' % str(wf.transitions.__dict__))
                if hasattr(wf.transitions, '_mapping'):
                    for transition in wf.transitions._mapping.keys():
                        transition_dict = {}
                        tlist_def = wf.transitions._mapping[transition]
                        tranid = tlist_def.getId()
                        guard = tlist_def.getGuard()
                        #out.write('Guard Definition dict for transition %s: %s\n' % (str(tranid), str(guard.__dict__)))
                        #out.write('Transition list: %s\n\n' % str(tlist_def))
                        a_tlist = {'id': tranid
                        ,}
                        name =  getattr(tlist_def, 'actbox_name', None)
                        if name: a_tlist['name'] = name
                        transition_dict['id'] = tranid
                        transition_dict['name'] = name
                        transition_dict['permission'] = guard.permissions
                        transitionlist.append(transition_dict)

    actionlist = []
    for dict in transitionlist:
        add_new = 1
        for final_dict in actionlist:
            if final_dict['id'] == dict['id']:
                add_new = 0
        if add_new:
            new_dict = {}
            new_dict['id'] = dict['id']
            new_dict['name'] = dict['name']
            permlist = []
            for perm in dict['permission']:
                permlist.append(perm)
            new_dict['permission'] = permlist
            actionlist.append(new_dict)
            
    zLOG.LOG('Get transitions', zLOG.INFO, 'Action list is: %s' % str(actionlist))

    if not actionlist:
        actionlist = [{'id': 'publish'
                     , 'name': 'Publish'
                     , 'permission': ['Review portal content']
                      }
                    , {'id': 'submit'
                     , 'name': 'Submit'
                     , 'permission': ['Request review']
                      }
                    , {'id': 'retract'
                     , 'name': 'Retract'
                     , 'permission': ['Request review']
                      }
                    , {'id': 'reject'
                     , 'name': 'Reject'
                     , 'permission': ['Review portal content']
                      }]

    zLOG.LOG('Get transitions', zLOG.INFO, 'Action list is: %s' % str(actionlist))
    return actionlist

def resolve_url(self, url, REQUEST):
    # resolve a fully qualified url to a Zope object.
    # return None on errors or if the url doesn't belong to this site.
    server = REQUEST.get('SERVER_URL')
    if url.find(server) != 0:
        return None

    root = self.portal_url.getPortalObject()
    path = url[len(server)+1:]
    try:
        obj = root.restrictedTraverse(path)
    except:
        pass
    return obj

def getenv(self, var, default=''):
    if not var in ('FTP_PORT','CHAT_PORT','CHATPORT'):
        raise "You are not allowed to access %s in this context" % var
    return os.getenv(var, default)